# Libgirl Avatar Chatbot Program Structure
## Making responses to users
### Input event pre-processing as `InMsg`
After pre-processing the input event and judge the source platform (i.e. messenger or line), the input event is parsed as the cross-platform bussiness-logic-centered data type `InMsg` that contains the contents of an input message and feed to `handleMessage()` (see `handle-msg.ts`). `OutMsg`, the cross-platform bussiness-logic-centered data type of output messages will then be generated and send to the uesrs. For `InMsg` and `OutMsg` please see `definition.ts`.

The 2nd argument of `handleMessage()` is a `Replier` (see `replier.ts`). We use `Replier`s as an unified interface to handle messages for 2 purposes:
1. To let the chatbot have different dialogue strategies on different platforms.
2. To let the strategies be independnt from the APIs of the platforms by dependency injection.

For each platform, a `Replier` have to be prepared.

### Generating `OutMsg` and sending messages by `Replier` & *Strategies*

The methods of a `Replier` takes an `inMsg`, generate `OutMsg`s, transform the `OutMsg`s to request bodies, make requests to the platforms for sending messages to the users, and then return a Promise. (For aws-lambda with asynchronous setting, it's required to return a promise to the entry `exports.handler`.)

There are 3 variants of types for an `InMsg` (see `definitions.ts`):
* `TextInMsg`: texts sent by user.
* `CmdInMsg`: commands made by user via Quick Replies or Buttons.
* `OtherInMsg`: any other input message, e.g. sticker or images.

The methods `.forText`, `.forCmd`, `.forNonText` of a `Replier` handles the 3 cases repectively, and these methods are composed of `StrategyForText`, `StrategyForCmd`, and `StrategyForNonText` repectively. The `sendAPI` trandforms `OutMsg`s as plat-form dependent request bodies and make requests to the platforms.

A *Strategy* takes an `InMsg` & the `preOutMsgs`, which are the `OutMsg`s generated by previous strategies, and then call other *Strategies* or call `sendAPI` on the `OutMsg`s generated by itself or the `preOutMsgs`.

The 2nd argument`preOutMsgs`, is used for re-use a replier in a strategy. For example, `genTakeAsCmd` judges whether the text input in identical to the text of a command, and then use the `Replier.forCmd` to handle the recognized command.

### Composing the *strategies* of the `Replier`s
The methods of a `Replier` use the functions `replyForText`, `replyForCmd` and `replyForNonText` (see `replier.ts`). From the start to the end of the argument `strategiesForText`, `strategiesForCmd`, and `strategiesForNonText`, the replying functions use the *strategy* at the point if the triggering conditions are fulfiled, or move to the next one. If no *strategy* is triggered, the argument `defaultStrategyFornText`, `defaultStrategyForCmd`, `defaultStrategyForNonText` will be used.

To select and design the strategies for handling the inputs, modify the `strategiesFor...` or `defaultStrategyFor...`, or modify a *strategy*.

### Using a *Stragegy*
Normaly a *strategy* function works based on these steps:
1. Judge whether conditions of the strategy are fulfilled.
2. If conditions are fulfilled, use the *strategy* to produce `OutMsg`s, call & return `sendAPI` on the generated `OutMsg`s or `preOutMsgs`, or call & return  other *stragegies*.
3. Call `finishStrategyForText`, `finishStrategyForCmd` or `finishStrategyForNontext` at the end of the *strategy* function to handle the case that the conditions are not fulfilled.

The `finishStrategyFor...` functions calls the `falseCallback`, which will be the next *strategy* in a `Replier`, propagates the optional argumments in `opt` to `falseCallback`, or return a `Promise` if `falseCallback` doesn't exist. With the helps from `finishStrategyFor...` functions, composing a *strategy* is mostly desiging the logic of step 1 and 2.

In Step 2, returning the called `sendAPI` or other *strategies* is also for aws-lambda with asynchronous setting.

### Making a new type of `OutMsg`
When making new features for the bot, we may have to create a new cross-platform bussiness-logic-centered output data type. Below are steps to create a new type of `OutMsg`:
1. Define a new class, e.g. `NewOutContent`, for the content and `implement OutContent`.
2. Define a new class, e.g. `NewOutMsg`, for the new output message and `implement OutMsg<NewOutContent>`.
3. Add a method in `OutParser` for the new output message, e.g. `newOut(msg: NewOutMsg): any[] | null`.
4. Add the new method, e.g. `newOut`, to the `OutParse`s of each platform.
5. declare the `NewOutMsg.outBodies` as `outParser.newOut(this)`.
6. add a switch case in `queue-pusher.ts reGenOutMsg` if this new `OutMsg` will be used for active push.

For the interface `OutMsg<T>`, the content of type `T` is its unique data structure and other properties are common for all output message types. You can use `extends BaseOutMsg` on `NewOutMsg` for DRY.

For exmples and informations please see `defenitions.ts`.
### Input & Output processing for Platforms
To be filled after migration to Bottender.

## Pushing messages to users actively
To make messages to be pushed, use `savePushTask` in `src/utils/push-queue/index.ts` to save an `OutMsg` to the DynamoDB table `PushQueue`.
To push messages, on lambda, the function `push-queue` executes periodically. Run locally by `npm run queue`. The triggered `pushQueue` in `src/queue-pusher` scan the table `PushQueue`, send messages to users and then delete the sent messages in the queue.
The `OutMsg` in the queue have to be deserialized back as object by `reGenOutMsg`, or the message will be simply dropped withoud push.
